/*

 e-Gizmo SEN-HZ21WA Flowmeter
 Sample Codes
 
 Reads the Digital Output on pin 5 and prints the result to
 the serial monitor.
 
 by
 e-Gizmo Mechatronix Central
 November 26, 2014
 http://www.e-gizmo.com

 */
int FLOW_PIN = 2;
double FLOW_RATE;
volatile int COUNT;

// the setup routine runs once when you press reset:
void setup() {
  // initialize serial communication at 9600 bits per second:
  Serial.begin(9600);
   pinMode(FLOW_PIN, INPUT);
  attachInterrupt(0, FLOW, RISING);
}

// the loop routine runs over and over again forever:
void loop() {
  COUNT = 0;      // Reset the counter
  interrupts();   //Enables interrupts on the Arduino
  delay (1000);   //Wait 1 second 
  noInterrupts(); //Disable the interrupts on the Arduino
  
  //Start the math
  FLOW_RATE = (COUNT * 2.25);        //Take counted pulses in the last second and multiply by 2.25mL 
  FLOW_RATE = FLOW_RATE * 60;         //Convert seconds to minutes, giving you mL / Minute
  FLOW_RATE = FLOW_RATE / 1000;       //Convert mL to Liters, giving you Liters / Minute

  Serial.println(FLOW_RATE);         //Print the variable flowRate to Serial
}
void FLOW()
{
   COUNT++; //Every time this function is called, increment "count" by 1
}
